;*****************************************************
;** Mxalloc-Patch zum entfernen der Protection-Bits **
;**            (TraPatch-Beispielmodul)             **
;**               (c) Jrg Westheide                **
;*****************************************************

err_illegal_fnum      = -99
err_no_xbra           = -98
err_xbra_not_found    = -97
err_lib_illegal       = -96
err_info_not_avaiable = -95
err_dupe              = -94


                bra main
                
                .dc.l 'XBRA'
                .dc.l 'Mxal'
old_vec:        .dc.l 0
                
patchmxalloc:   
                
                and.w #3, 4(a0)         ; alle, auer den ST/TT-RAM-Bits lschen
                
                move.l old_vec, -(sp)
                rts
                
                
;****************  bis hier hin resident  ***************

_p_cookie  =  $5A0.w

tp_install   = 0
tp_deinstall = 4
tp_info      = 8

main:           
                
                movea.l 4(sp),a5
                move.l  $0C(a5),d0      ;Laenge Text-Segment
                add.l   $14(a5),d0      ;Laenge Data-Segment
                add.l   $1C(a5),d0      ;Laenge Bss-Segment
                add.l   #$0200,d0       ;Laenge Basepage
                
                move.l a5, -(sp)    ; fr Grenbrechnung fr Ptermres
                
                move.l d0, -(sp)
                move.l a5, -(sp)
                clr.w -(sp)
                move.w #$4A, -(sp)
                trap #1
                adda.w #12, sp
                
                pea hello_text
                move.w #9, -(sp)
                trap #1
                addq.l #6,sp
                                
                move.l #init, -(sp)
                move.w #38, -(sp)
                trap #14
                addq.l #6, sp
                
                tst.w errflag
                bmi abort
                
                move.l (sp)+, d0
                clr.w -(sp)
                move.l d0, -(sp)
                lea main, a0
                suba.l d0, a0    ; Gre des Speicherbereichs /*Anfangsadresse der Basepage*/
                move.l  a0,-(sp)        ; Speichergre fr Ptermres
                move.w  #$31,-(sp)
                trap    #1              ;Speicherplatz reservieren

                
abort:          
                
                
                pea err_text      ; Text "Installation abgebrochen" ausgeben
                move.w #9, -(sp)
                trap #1
                addq.l #6,sp
                
                move.w #8, -(sp)  ; auf Taste warten
                trap #1
                addq.l #2, sp
                
                pea after_key     ; Teile lschen
                move.w #9,-(sp)
                trap #1
                addq.l #6, sp
                
                clr.w -(sp)       ; Ende
                trap #1
                
                
init:           
                
                move.l #'TraP', d0
                
                move.w SR, d1
                move.w #$2700, SR

                move.l _p_cookie, a0
                
cookieloop:                             ; Cookie 'TraP' suchen
                
                move.l (a0)+, d2
                beq not_found
                
                cmp.l d2, d0
                beq cookie_found
                
                addq.l #4, a0
                bra cookieloop
                
                
cookie_found:   
                
                move.w d1, SR
                
                move.l (a0), a0   ; Zeiger auf Cookie nach a0
                
                move.l a0, -(sp)  ; a0 retten
                
                clr.w -(sp)            ; GEMDOS
                move.w #2, -(sp)       ; Anzahl Tabelleneintrge ermitteln
                
                move.l tp_info(a0), a0 ; tp_info
                jsr (a0)               ; anspringen
                
                addq.l #4, sp
                
                move.l (sp)+, a0  ; a0 restaurieren
                
                cmpi.w #$44, d0          ; Eintrag fr Mxalloc vorhanden?
                ble no_mxalloc_support   ; nein -> Fehlermeldung
                
                clr.l -(sp)                 ; das reservierte long
                pea patchmxalloc            ; Adresse der neuen Routine
                move.w #$44, -(sp)          ; Mxalloc 
                clr.w -(sp)                 ; GEMDOS

                move.l tp_install(a0), a0   ; tp_install
                jsr (a0)                    ; anspringen
                
                lea 12(sp), sp

                tst.l d0
                bmi analyse_err
                                
                rts
                
                
analyse_err:
                
                cmpi.l #err_dupe, d0
                beq dupe_error
                
                move.w #-1, errflag
                rts
                
dupe_error:     
                
                pea dupe_text
                bra err_text_out
                               
                                
no_mxalloc_support:

                pea no_mx_text
                bra err_text_out


not_found:      
                
                move.w d1, SR      ; Interrupts wieder freigeben
                
                pea no_trapper

err_text_out:

                move.w #9, -(sp)
                trap #1
                addq.l #6,sp
                
                move.w #-1, errflag
                rts



.data
errflag:        .dc.w 0
hello_text:     .dc.b 13,10,27,'p TraPatch-Modul Mxalloc-Patch (24.08.1995) ',27,'q',13,10,' (c) Jrg Westheide',13,10,0
err_text:       .dc.b ' Installation abgebrochen!',13,10,' <Taste>',13,0
no_trapper:     .dc.b ' TraPatch nicht installiert! ',13,10,0
no_mx_text:     .dc.b ' Bitte konfigurieren sie in TraPatch',13,10
                .dc.b ' als grte GEMDOS-Funktionsnummer',13,10
                .dc.b ' einen Wert >= 68!', 13,10,0
dupe_text:      .dc.b ' Mxalloc-Patch ist bereits installiert!',13,10,0                
after_key:      .dc.b 27,'K',0
